astro_smart_deploy:
  stage: deploy
  image: docker:latest
  services:
    - docker:dind
  variables:
    ASTRO_API_TOKEN: ${PROD_ASTRO_API_TOKEN}
    DAG_FOLDER: "dags"
    DEPLOYMENT_ID: ${PROD_DEPLOYMENT_ID}
  before_script:
    - apk add --update curl && rm -rf /var/cache/apk/*
    - apk add git
    - apk add bash
  script:
    - (curl -sSL install.astronomer.io | bash -s)
    - files=$(git diff --name-only  $(git rev-parse HEAD~1) -- .)
    - dags_only=1
    - echo "$DAG_FOLDER"
    - echo "$files"
    - for file in $files; do
    -   echo "$file"
    -   if [[ "$file" != "$DAG_FOLDER"* ]]; then
    -     echo "$file is not a dag, triggering a full image build"
    -     dags_only=0
    -     break
    -   else
    -     echo "just a DAG"
    -   fi
    - done
    - echo "$dags_only"
    - if [[ $dags_only == 1 ]]; then
    -   echo "doing dag-only deploy"
    -   astro deploy --dags $DEPLOYMENT_ID
    - elif [[ $dags_only == 0 ]]; then
    -   echo "doing image deploy"
    -   astro deploy -f $DEPLOYMENT_ID
    - fi
  only:
    - main